commit abdd9067ec58d17cbd2fd56f71f220b4b7b6a23d
Author: Your Name <you@example.com>
Date:   Tue Dec 2 08:58:47 2014 +0000

    backport query limiter to 3.2

diff --git a/pdns_recursor.cc b/pdns_recursor.cc
index 61d0c51..b609cb8 100644
--- a/pdns_recursor.cc
+++ b/pdns_recursor.cc
@@ -523,7 +523,14 @@ void startDoResolve(void *p)
     int res;
 
     if(!t_pdl->get() || !(*t_pdl)->preresolve(dc->d_remote, g_listenSocketsAddresses[dc->d_socket], dc->d_mdp.d_qname, QType(dc->d_mdp.d_qtype), ret, res)) {
-       res = sr.beginResolve(dc->d_mdp.d_qname, QType(dc->d_mdp.d_qtype), dc->d_mdp.d_qclass, ret);
+      try {
+        res = sr.beginResolve(dc->d_mdp.d_qname, QType(dc->d_mdp.d_qtype), dc->d_mdp.d_qclass, ret);
+      }
+      catch(ImmediateServFailException &e) {
+        L<<Logger::Error<<"Sending SERVFAIL during resolve of '"<<dc->d_mdp.d_qname<<"' because: "<<e.reason<<endl;
+
+        res = RCode::ServFail;
+      }
 
       if(t_pdl->get()) {
         if(res == RCode::NXDomain)
diff --git a/syncres.cc b/syncres.cc
index fb8bba5..d1c9f14 100644
--- a/syncres.cc
+++ b/syncres.cc
@@ -864,6 +864,7 @@ int SyncRes::doResolveAt(set<string, CIStringCompare> nameservers, string auth,
           }
           else {
             s_outqueries++; d_outqueries++;
+            if(d_outqueries > 50) throw ImmediateServFailException("more than 50 queries sent while resolving "+qname);
           TryTCP:
             if(doTCP) {
               LOG<<prefix<<qname<<": using TCP with "<< remoteIP->toStringWithPort() <<endl;
diff --git a/syncres.hh b/syncres.hh
index 22645a2..159a037 100644
--- a/syncres.hh
+++ b/syncres.hh
@@ -506,6 +506,13 @@ replacing_insert(Index& i,const typename Index::value_type& x)
   return res;
 }
 
+class ImmediateServFailException
+{
+public:
+  ImmediateServFailException(string r){reason=r;};
+
+  string reason; //! Print this to tell the user what went wrong
+};
 
 std::string reloadAuthAndForwards();
 ComboAddress parseIPAndPort(const std::string& input, uint16_t port);
